/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest{}

// AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest struct for AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest
type AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest struct {
	DestinationId *string `json:"destinationId,omitempty"`
}

// NewAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest instantiates a new AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest() *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest {
	this := AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest{}
	return &this
}

// NewAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequestWithDefaults instantiates a new AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequestWithDefaults() *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest {
	this := AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest{}
	return &this
}

// GetDestinationId returns the DestinationId field value if set, zero value otherwise.
func (o *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) GetDestinationId() string {
	if o == nil || IsNil(o.DestinationId) {
		var ret string
		return ret
	}
	return *o.DestinationId
}

// GetDestinationIdOk returns a tuple with the DestinationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) GetDestinationIdOk() (*string, bool) {
	if o == nil || IsNil(o.DestinationId) {
		return nil, false
	}
	return o.DestinationId, true
}

// HasDestinationId returns a boolean if a field has been set.
func (o *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) HasDestinationId() bool {
	if o != nil && !IsNil(o.DestinationId) {
		return true
	}

	return false
}

// SetDestinationId gets a reference to the given string and assigns it to the DestinationId field.
func (o *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) SetDestinationId(v string) {
	o.DestinationId = &v
}

func (o AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.DestinationId) {
		toSerialize["destinationId"] = o.DestinationId
	}
	return toSerialize, nil
}

type NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest struct {
	value *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest
	isSet bool
}

func (v NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) Get() *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest {
	return v.value
}

func (v *NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) Set(val *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest(val *AppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) *NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest {
	return &NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest{value: val, isSet: true}
}

func (v NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppDestinationGoogleSheetsGoogleSheetsDestinationActionAvailableSpreadsheetsRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
